/* FILE: ser_inp.dsp            Copyright (c), Symmetric Research, 1993 1998
 *
 * Input some data from the DSP32C serial input port (SIP).
 *
 *
 *
 *
 */

main {

        register

                nwords  = r1,
                p       = r2;




        /* Program the SIP to be driven by external ICK and ILD */

        ioc = ( ICK_EXT | ILD_EXT | ILEN_32 );




        /* Wait in an infinite loop to read the SIP. */

  wait:
        nwords = ibuf.l;



            if ( nwords > 0 ) {   /* receive the transmission ... */


                    p = input_array;


                    while ( nwords > 0 ) {

                            if ( ibf )

                                    { *p++ = ibuf.l; nwords--; }

                            }
                    }



        goto wait;  /* continue waiting for the next transmission */


}






/* Input array area:
 *
 *
 *
 */

<0x100> long

        input_array[0x100] = { 0 };








/* Serial port IOC control register bit assigments:
 *
 * These constants define the bit assigments for the serial port IOC
 * configuration control register.  They provide convenient mnemonic names
 * for the bits.
 *
 *
 */

constant


        SY_EXT          = 0x0 << 0x00,          /* sy external          */
        SY_INT          = 0x1 << 0x00,          /* sy internal          */

        BC_ICK          = 0x0 << 0x01,          /* load/sy from ICK     */
        BC_OCK          = 0x1 << 0x01,          /* load/sy from OCK     */

        SLEN_00         = 0x0 << 0x02,          /* load/sy ratios       */
        SLEN_08         = 0x1 << 0x02,
        SLEN_16         = 0x2 << 0x02,
        SLEN_32         = 0x3 << 0x02,

        ICK_EXT         = 0x0 << 0x04,          /* ICK external         */
        ICK_INT         = 0x1 << 0x04,          /* ICK internal         */

        ILD_EXT         = 0x0 << 0x05,          /* ILD external         */
        ILD_INT         = 0x1 << 0x05,          /* ILD internal         */

        ILEN_00         = 0x0 << 0x06,          /* input length         */
        ILEN_08         = 0x1 << 0x06, 
        ILEN_16         = 0x2 << 0x06,
        ILEN_32         = 0x3 << 0x06,

        OCK_EXT         = 0x0 << 0x08,          /* OCK external         */
        OCK_INT         = 0x1 << 0x08,          /* OCK internal         */

        OLD_EXT         = 0x0 << 0x09,          /* OLD external         */
        OLD_INT         = 0x1 << 0x09,          /* OLD internal         */

        OLEN_00         = 0x0 << 0x0A,          /* output length        */
        OLEN_08         = 0x1 << 0x0A,
        OLEN_16         = 0x2 << 0x0A,
        OLEN_32         = 0x3 << 0x0A,

        SANITY          = 0x1 << 0x0C,          /* set sanity           */

        DMA_00          = 0x0 << 0x0D,          /* no dma               */
        DMA_01          = 0x1 << 0x0D,          /* in IBF               */
        DMA_02          = 0x2 << 0x0D,          /* out OBE              */
        DMA_03          = 0x3 << 0x0D,          /* in IBF, out OBE      */
        DMA_04          = 0x4 << 0x0D,          /* in/out IBF&OBE       */
        DMA_05          = 0x5 << 0x0D,          /* in/out IBF           */
        DMA_06          = 0x6 << 0x0D,          /* in/out OBE           */
        DMA_07          = 0x7 << 0x0D,          /* in/out IBF|OBE       */

        IN_LSB          = 0x0 << 0x10,          /* input lst first      */
        IN_MSB          = 0x1 << 0x10,          /* input msb first      */

        OUT_LSB         = 0x0 << 0x11,          /* output lsb first     */
        OUT_MSB         = 0x1 << 0x11,          /* output msb first     */

        CKI_FAST        = 0x0 << 0x12,          /* clock = CKI/8        */
        CKI_SLOW        = 0x1 << 0x12,          /* clock = CKI/24       */

        O24             = 0x1 << 0x13,          /* out len 24 bits      */
        DSZ             = 0x1 << 0x14;          /* dma size ILEN/OLEN   */

