/* FILE: dsp32ckd.h                Copyright (c), Symmetric Research, 1999-2000
 *
 * Linux kernel mode driver include file containing IOCTL codes.
 *
 */


#include <linux/ioctl.h>     /* ioctl macros */


/*
 * Define common names for the device driver.
 *
 */

#define MODULE_FILE      "dsp32ckd"
#define DEVICE_NAME      "dsp32c"
#define DLL_DEVICE_NAME  "/dev/dsp32c"



/*
 * Define structures to facilitate passing data between the DLL and
 * the device driver.
 *
 */

typedef struct _PassedParms {
        
        unsigned long baseio;
        unsigned long basesel;
        unsigned long reg_offset;
        short         value;
        
        } PASSEDPARMS;


typedef struct _PassedBuffParms {
        
        unsigned long dspaddr;
        unsigned long count;
        char         *buffer;
        
        } PASSEDBUFFPARMS;





/* Define device type and access type for IOCTL functions */

#define  DSP32C_DEVICE_TYPE  0x25
#define  _IOC_RW            (_IOC_READ | _IOC_WRITE)



/*
 * The I/O Control codes are used to indicate which function the
 * hardware device should perform.
 *
 */




#define IOCTL_DSP32C_DSPGETBASE _IOWR( DSP32C_DEVICE_TYPE, 0, PASSEDPARMS )
#define IOCTL_DSP32C_DSPSETBASE _IOW(  DSP32C_DEVICE_TYPE, 1, PASSEDPARMS )
#define IOCTL_DSP32C_DSPIN      _IOR(  DSP32C_DEVICE_TYPE, 2, PASSEDPARMS )
#define IOCTL_DSP32C_DSPOUT     _IOW(  DSP32C_DEVICE_TYPE, 3, PASSEDPARMS )
#define IOCTL_DSP32C_DSPINSW    _IOWR( DSP32C_DEVICE_TYPE, 4, PASSEDBUFFPARMS )
#define IOCTL_DSP32C_DSPOUTSW   _IOW(  DSP32C_DEVICE_TYPE, 5, PASSEDBUFFPARMS )
#define IOCTL_DSP32C_DSPOUTLONG _IOW(  DSP32C_DEVICE_TYPE, 6, PASSEDBUFFPARMS )
#define IOCTL_DSP32C_DSPSELOUT  _IOW(  DSP32C_DEVICE_TYPE, 7, long )
#define IOCTL_DSP32C_MAXNR                                 8
