/* FILE: mmult.dsp              Copyright (c), Symmetric Research, 1992
 *
 * This is the DSPASM portion of the mmult.c example program, computing
 * y = A*x.
 *
 *
 */


/* Program layout.  Make sure INPUT and OUTPUT agree with mmult.c */

constant

        RESET   = 0000000,
        INPUT   = 0000100,
        OUTPUT  = 0000200,

        BUSY    = 0,
        DONE    = 1;




/* PC Communications area. */

<INPUT>

        ieee A[9], x[3];  <OUTPUT> ieee y[3];


/*
 * Note that DSPASM does not have doubly dimensioned arrays, so A[3][3] in
 * mmult.c is declared as A[9] here.
 *
 */



/* Program to compute y = A*x. */

<RESET> main {


        /* Set the pir register to BUSY. */

        r1 = BUSY; pir = r1;


        /* Convert A and x to dspf floats. */

        r1 = A; do 0C

                { *r1++ = a0 = dsp( *r1); }



        /* Compute y = A*x, using simple in line code. */

        r1 = A; r2 = x; r3 = y;

                a0 =      *r1++ * *r2++;        /* first row            */
                a0 = a0 + *r1++ * *r2++;
        *r3++ = a0 = a0 + *r1++ * *r2++;



        r2 = x;

                a0 =      *r1++ * *r2++;        /* second row           */
                a0 = a0 + *r1++ * *r2++;
        *r3++ = a0 = a0 + *r1++ * *r2++;



        r2 = x;

                a0 =      *r1++ * *r2++;        /* third row            */
                a0 = a0 + *r1++ * *r2++;
        *r3++ = a0 = a0 + *r1++ * *r2++;



        /* Convert y back to IEEE floats. */

        r1 = y;

        do 3
                { *r1++ = a0 = ieee( *r1); }



        /* Set the pir register to DONE, and wait for the PC. */

        r1 = DONE; pir = r1; wait: goto wait;

}
